# Copyright (c) 2014, 2015  Dave Love, University of Liverpool
# Copyright (c) 2018  Dave Love, University of Manchester
# MIT licence, per Fedora policy.

# Fixme: There are lots of warnings about bad formats and implicit
# declarations.  The format issues which are wrong on x86_64, should be
# fixed by the patch.
# Build a shared version
# There are rpmlint errors.
# Version 1.8 won't build with gfortran 4.4 (el6)
# mpich version

Name:		adios
Version:	1.13.1
Release:	1%{?dist}
Summary:	Adaptable IO system for simulations
License:	BSD
URL:		http://www.olcf.ornl.gov/center-projects/adios/
Source0:	http://users.nccs.gov/~pnorbert/adios-%version.tar.gz
Patch1:         adios-char.patch
BuildRequires:	openmpi-devel zlib-devel hdf5-openmpi-devel netcdf-devel
BuildRequires:	bzip2-devel lz4-devel gcc-c++ /usr/bin/python3
BuildRequires:	libibverbs-devel automake libtool


%global desc \
The Adaptable IO System (ADIOS) provides a simple, flexible way for scientists\
to describe the data in their code that may need to be written, read,\
or processed outside of the running simulation. By providing an external\
to the code XML file describing the various elements, their types, and\
how you wish to process them this run, the routines in the host code\
(either Fortran or C) can transparently change how they process the data.

%package openmpi
Summary:	Adaptable IO system for simulations
Requires:	openmpi%{?_isa}
Provides:	bundled(mxml) = 2.9 bundled(zfp) = 0.5.0

%description
%desc

%description openmpi
%desc

This version is built against openmpi, with support for parallel HDF
and zlib.

%package openmpi-devel
Summary:	Development files for %name
Requires:	%name-openmpi%{?_isa} = %version
Requires:	openmpi-devel%{?_isa}

%description openmpi-devel
Development files for %name


%prep
%setup -q
%patch1 -p1


%build
autoreconf -fiv
%_openmpi_load
# --enable-shared doesn't actually work.
export CFLAGS='-Wno-unused-function'
export CXXFLAGS=$CFLAGS
%configure --with-phdf5=$MPI_HOME \
  --sysconfdir=$MPI_SYSCONFIG --bindir=$MPI_BIN --libdir=$MPI_LIB \
  --includedir=$MPI_INCLUDE \
  --with-phdf5-libdir=$MPI_LIB --with-phdf5-incdir=$MPI_INCLUDE \
  --with-lz4=%_prefix --with-zlib=%_prefix --with-bzip2=%_prefix \
  --with-netcdf=%_prefix # --enable-shared --disable-static
# parallel build fails
make
%_openmpi_unload


%install
%_openmpi_load
%make_install
mkdir -p $RPM_BUILD_ROOT%_sysconfdir/adios $RPM_BUILD_ROOT$MPI_LIB
mkdir -p $(dirname $RPM_BUILD_ROOT%python_sitelib) $RPM_BUILD_ROOT$MPI_FORTRAN_MOD_DIR
mv $RPM_BUILD_ROOT%_prefix/etc/skel $RPM_BUILD_ROOT%_sysconfdir/adios
mv $RPM_BUILD_ROOT$MPI_LIB/python $RPM_BUILD_ROOT%python_sitelib
chmod +x $RPM_BUILD_ROOT$MPI_BIN/*.py
mv $RPM_BUILD_ROOT$MPI_INCLUDE/*.mod $RPM_BUILD_ROOT$MPI_FORTRAN_MOD_DIR
mkdir -p $RPM_BUILD_ROOT$MPI_HOME/share
mv $RPM_BUILD_ROOT%_sysconfdir/openmpi-%_arch $RPM_BUILD_ROOT$MPI_HOME/share/cmake
%_openmpi_unload
find %buildroot -name \*.py | xargs sed -i -r -e 's,/usr/bin/(env )?python$,\03,'
sed -i -r -e 's,/usr/bin/(env )?python$,\03,' %buildroot%_libdir/openmpi/bin/skel


%files openmpi
%license COPYING
%doc AUTHORS NEWS README.md KNOWN_BUGS TODO
%_libdir/openmpi/bin/*
%exclude %python_sitelib/argparse.*
%python_sitelib/*
%dir %_sysconfdir/adios
%config(noreplace) %_sysconfdir/adios/*

%files openmpi-devel
%_includedir/openmpi-%_arch
%_fmoddir/openmpi-%{_arch}%{?_opt_cc_suffix}/*
%dir %_libdir/openmpi/share/cmake
%_libdir/openmpi/share/cmake/FindADIOS.cmake
%_libdir/openmpi/share/cmake/adios*
%_libdir/openmpi/lib/*.a


%changelog
* Wed Oct 31 2018 Dave Love <loveshack@fedoraproject.org> - 1.13.1-1
- New version
- Use bundled MXML
- Enable netcdf (serial)

* Wed Jul 01 2015 Dave Love <d.love@liverpool.ac.uk> - 1.7.0-3
- Install the .a files

* Mon Jun 29 2015 Dave Love <d.love@liverpool.ac.uk> - 1.7.0-2
- Rename to adios-openmpi
- Add devel package
- Fix more formats

* Sun Nov 23 2014 Dave Love <d.love@liverpool.ac.uk> - 1.7.0-1
- New version

* Sat Jun 28 2014 Dave Love <d.love@liverpool.ac.uk> - 1.6.0-2
- Modify Fortran module installation

* Fri Apr 25 2014 Dave Love <d.love@liverpool.ac.uk> - 1.6.0-1
- Initial packaging
